package inf112.skeleton.app;

import javafx.geometry.Bounds;
import javafx.scene.canvas.Canvas;
import javafx.scene.canvas.GraphicsContext;
import javafx.scene.image.ImageView;
import javafx.scene.paint.Color;

import javax.imageio.ImageIO;
import javax.imageio.stream.ImageInputStream;
import java.awt.*;
import java.awt.image.BufferedImage;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.net.URL;

import javafx.scene.image.Image;

public class Player {
    int x, y, w, h;
    public int speed = 5;
    public int gravity = 5;
    boolean move_left = false;
    boolean move_right = false;
    boolean jump = false;
    public int frames = 0;
    boolean canMoveLeft, canMoveRight, canMoveDown, canMoveUp;

    Image playerImg, pLeft, pRight, waffle, runningR;
    String direction = "Left";
    boolean onGround = false;

    public Player() {
        PlayerValues();
        GetPlayerImage();
    }

    public void PlayerValues() {
        this.x = 45;
        this.y = 50;
        this.w = 60;
        this.h = 60;
    }

    public int getHeight() {
        return this.h;
    }

    public int getWidth() {
        return this.w;
    }

    public int getX() {
        return this.x;
    }

    public int getY() {
        return this.y;
    }

    public int getSpeed() {
        return this.speed;
    }

    public void GetPlayerImage() {

        this.playerImg = new Image("file:src/PlayerImage/Player.png");
        this.pLeft = new Image("file:src/PlayerImage/pLeft.png");
        this.pRight = new Image("file:src/PlayerImage/pRight.png");
        this.waffle = new Image("file:src/PlayerImage/waffle.png");

    }

    public void Move() {
        if (move_left && canMoveLeft) {
            direction = "Left";
            this.x -= this.speed;
        }
        if (move_right && canMoveRight){
            direction = "Right";
            this.x += this.speed;
        }
        if (jump && canMoveUp) {
            onGround = false;
            if(frames < 25) {
                frames++;
                this.y -= 6;
            }
            else {
                frames = 0;
                jump = false;
            }
        }
        if(!jump && canMoveDown) {
            this.y += gravity;
        }

    }
    public void drawPlayer(GraphicsContext gc) {
      //gc.setFill(Color.WHITE);
      //gc.fillRect(x - w/2, y - h/2, w, h);

        Image image = switch (direction) {
            case "Left" -> pLeft;
            case "Right" -> pRight;
            default -> null;
        };

        gc.drawImage(image, x - w/2.0, y - h/2.0, w, h);
    }

    public void checkCollision(Wall w) {
        // Player sides
        int p_LeftSide = this.getX() - this.getWidth()/2;
        int p_RightSide = this.getX() + this.getWidth()/2;
        int p_DownSide = this.getY() + this.getHeight()/2;
        int p_UpperSide = this.getY() - this.getHeight()/2;

        // Wall sides
        int w_LeftSide = w.getX() - w.getWidth()/2;
        int w_RightSide = w.getX() + w.getWidth()/2;
        int w_DownSide = w.getY() + w.getHeight()/2;
        int w_UpperSide = w.getY() - w.getHeight()/2;

        boolean leftsideCollide = p_LeftSide - this.getSpeed() < w_RightSide && p_LeftSide > w_LeftSide;
        boolean rightsideCollide = p_RightSide < w_RightSide && p_RightSide + this.getSpeed() > w_LeftSide;
        boolean heightCollide = p_DownSide > w_UpperSide && p_UpperSide < w_DownSide;

        boolean downsideCollide = p_DownSide + this.gravity > w_UpperSide && p_DownSide < w_DownSide;
        boolean upsideCollide = p_UpperSide > w_UpperSide && p_UpperSide < w_DownSide;
        boolean sidesCollide = p_LeftSide < w_RightSide && p_RightSide > w_LeftSide;

        // CHECK LEFT
        if (leftsideCollide && heightCollide) canMoveLeft = false;

        // CHECK RIGHT
        if (rightsideCollide && heightCollide) canMoveRight = false;

        //CHECK DOWN
        if (downsideCollide && sidesCollide) {
            canMoveDown = false;
            onGround = true;
        }

        //CHECK UP
        if (upsideCollide && sidesCollide) {
            canMoveUp = false;
            jump = false;
            frames = 0;
        }

    }

}
